## msxpertsuite 5.7.2

=== CMakeLists.txt ===
#############################################################
# CMake configuration
cmake_minimum_required(VERSION 3.0)

# Add folder where are supportive functions
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/CMakeStuff)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_COLOR_MAKEFILE ON)
set(CMAKE_VERBOSE_MAKEFILE ON)

# This export will allow using the flags to be used by
# youcompleteme (vim plugin).
set(CMAKE_EXPORT_COMPILE_COMMANDS 1)

# We want C++11
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)
# deprecated, cmake does the job: ADD_DEFINITIONS(-std=c++11)

# We do not want warnings for unknown pragmas:
ADD_DEFINITIONS(-Wno-unknown-pragmas)

# Include the various colors we want to use in the output
include(outputColors)

# Include the system's uname that fills in SYSTEM_UNAME_S.
# Sets WIN64 if SYSTEM_UNAME_S is "^.*MING64.*"
include(systemUname)


############################################################
# Basic information about project

project(msXpertSuite)
set(VERSION 5.7.2)


# Set additional project information
set(COMPANY "msXpertSuite.org")
set(COPYRIGHT "Copyright (c) 2008-2018 Filippo Rusconi. Licensed under GPLv3+")
set(IDENTIFIER "org.msxpertsuite")


message("")
message(STATUS "${BoldGreen}Starting configuration of msXpertSuite${ColourReset}")
message(STATUS "${BoldYellow}System is detected by CMake as ${SYSTEM_UNAME_S}${ColourReset}")
message("")


# No need to specify position independent code flag on MING64_NT
# because that flag is set automatically and it triggers an error when -Werror
# is set.
if(NOT WIN64)
	ADD_DEFINITIONS(-fPIC)
endif()

if(APPLE)
	add_definitions("-DAPPLE=1")
	add_definitions("-stdlib=libc++")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
	message(STATUS "using ${CMAKE_CXX_FLAGS}")
endif()

########################################################
# Source tree preparation
# On windows and mac, some libraries are added to the source tree
# while on Debian GNU/Linux there libraries are packaged.
########################################################

if(APPLE OR WIN64)

	message(STATUS "should copy the qcustomplot directory.")

	# This include must come before all the others
	# It must include the config-generated config.h file
	# before the others.
	include_directories(${CMAKE_BINARY_DIR})

	# Copy the qcustomplot directory to the source tree
	execute_process(COMMAND cp -vrp ${CMAKE_SOURCE_DIR}/../helper-libs/qcustomplot
		${CMAKE_SOURCE_DIR}
		WORKING_DIRECTORY	${CMAKE_SOURCE_DIR})

	set(QCUSTOMPLOT_SRC_DIR ${CMAKE_SOURCE_DIR}/qcustomplot)
	include_directories(${QCUSTOMPLOT_SRC_DIR})

	# Copy the tclap directory to the source tree
	message(STATUS "should copy the tclap directory.")

	execute_process(COMMAND cp -vrp ${CMAKE_SOURCE_DIR}/../helper-libs/tclap
		${CMAKE_SOURCE_DIR}
		WORKING_DIRECTORY	${CMAKE_SOURCE_DIR})

	set(TCLAP_SRC_DIR ${CMAKE_SOURCE_DIR}/tclap)
	include_directories(${CMAKE_SOURCE_DIR})

endif()



#############################################################
# On MINGW.* we provide a number of libraries by our own, that we
# put mingw64/usr/local/lib
if(WIN64)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -L/mingw64/usr/local/lib")
endif()


#############################################################
# Enable warnings and possibly treat them as errors
add_definitions(-Wall)

if(WARNASERR)
	message(STATUS "${BoldYellow}Warnings treated as errors.${ColourReset}")
	add_definitions(-Werror)
endif()

# On MINGW64_NT, we want to build as release, otherwise build as debug.
if(WIN64)
	set(CMAKE_BUILD_TYPE "release")
	add_definitions(-DQT_NO_DEBUG)
else()
	if(NOT CMAKE_BUILD_TYPE STREQUAL "release")
		set(CMAKE_BUILD_TYPE "debug")
	endif()
endif()

# But the user may want something easier to set: -DDEBUG
if(DEBUG)
	set(CMAKE_BUILD_TYPE "debug")
endif()

if(CMAKE_BUILD_TYPE STREQUAL "debug")
	add_definitions(-g -O0)
	message(STATUS "${BoldYellow}Debug support requested. Adding -g -O0.${ColourReset}")
else()
	add_definitions(-O3)
	message(STATUS "${BoldYellow}Debug support NOT requested. Adding -O3.${ColourReset}")
endif()

if(APPLE)
	link_directories("/opt/local/lib")
endif()

if(OPENMP)
	message(STATUS "${BoldYellow}OpenMP support is requested, adding -fopenmp flag.${ColourReset}")
	if(APPLE)
		include_directories("/opt/local/include/libomp")
		link_directories("/opt/local/lib/libomp")
	else()
		add_definitions(-fopenmp)
	endif()

	# Depending on the compiler, if we need the omp.h header file,
	# we'll have to look for it in different locations.

	message(STATUS "${BoldRed}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")
	message(STATUS "${BoldRed}CMAKE_SOURCE_DIR: ${CMAKE_SOURCE_DIR}${ColourReset}")

	if(CMAKE_CXX_COMPILER MATCHES ".*clang.*")
		message(STATUS "${BoldRed}Using clang++${ColourReset}")
		include_directories("${CMAKE_SOURCE_DIR}/clang-openmp")
		link_directories("${CMAKE_SOURCE_DIR}/clang-openmp")
		set(OPENMP_LIBRARY omp)
	else()
		message(STATUS "${BoldRed}Not using clang++${ColourReset}")
		set(OPENMP_LIBRARY gomp)
	endif()

	message(STATUS "${BoldYellow}Using parallelizing library ${OPENMP_LIBRARY}${ColourReset}")
endif()

if(PROFILE)
	message(STATUS "${BoldYellow}Profiling is requested, adding -pg flag.${ColourReset}")
	add_definitions(-pg)
endif()


message(STATUS "${BoldYellow}Main CMAKE_BINARY_DIR: ${CMAKE_BINARY_DIR}${ColourReset}")
message(STATUS "${BoldYellow}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")

# For the config.h file.
set(CMAKE_INCLUDE_CURRENT_DIR ON)

add_subdirectory(globals)
add_subdirectory(libmass)
add_subdirectory(libmassgui)

# It is essential to run these config steps before delving into the massxpert
# and minexpert directories, because at that moment they will need what are
# going to prepare right now.
CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/CMakeStuff/splashscreen.svg.in
	${CMAKE_SOURCE_DIR}/images/splashscreen.svg @ONLY)

CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/CMakeStuff/msxpertsuite-macros.tex.in
	${CMAKE_SOURCE_DIR}/user-manual-common/texfiles/msxpertsuite-macros.tex @ONLY)

CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/CMakeStuff/msxpertsuite-mingw64-win7+.iss.in
	${CMAKE_SOURCE_DIR}/winInstaller/msxpertsuite-mingw64-win7+.iss @ONLY)

# Make the conversion of the svg file into a png, but only on GNU/Linux
if(UNIX AND NOT APPLE)
	execute_process(COMMAND convert ${CMAKE_SOURCE_DIR}/images/splashscreen.svg
		${CMAKE_SOURCE_DIR}/images/splashscreen.png)
endif()

# In the following subdirectories, we'll set all the install directories, that
# will always be a subdirectory of the CMake-default CMAKE_INSTALL_PREFIX.

############################## MASSXPERT #############################
add_subdirectory(massxpert)

get_directory_property(MASSXPERT_TARGET_NAME
	DIRECTORY massxpert
	MASSXPERT_TARGET_NAME)

get_directory_property(MASSXPERT_BIN_DIR
	DIRECTORY massxpert
	MASSXPERT_BIN_DIR)

get_directory_property(MASSXPERT_JAVASCRIPT_DIR
	DIRECTORY massxpert
	MASSXPERT_JAVASCRIPT_DIR)

get_directory_property(MASSXPERT_DATA_DIR
	DIRECTORY massxpert
	MASSXPERT_DATA_DIR)

get_directory_property(MASSXPERT_DOC_DIR
	DIRECTORY massxpert
	MASSXPERT_DOC_DIR)

############################## MINEXPERT #############################
add_subdirectory(minexpert)

get_directory_property(MINEXPERT_TARGET_NAME
	DIRECTORY minexpert
	MINEXPERT_TARGET_NAME)

get_directory_property(MINEXPERT_BIN_DIR
	DIRECTORY minexpert
	MINEXPERT_BIN_DIR)

get_directory_property(MINEXPERT_JAVASCRIPT_DIR
	DIRECTORY minexpert
	MINEXPERT_JAVASCRIPT_DIR)

get_directory_property(MINEXPERT_DATA_DIR
	DIRECTORY minexpert
	MINEXPERT_DATA_DIR)

get_directory_property(MINEXPERT_DOC_DIR
	DIRECTORY minexpert
	MINEXPERT_DOC_DIR)

# Use all the configured paths to create the config.h file.
# The config.h file is generated in the CMAKE_BINARY_DIR!!!
CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/CMakeStuff/config.h.in
	config.h @ONLY)

add_subdirectory(doc)

add_subdirectory(devdoc)

if(TESTS)
	add_subdirectory(tests)
endif()

#############################################################
# summary
message("")
message(STATUS "${BoldRed}~~~~~~~~~~~~~~~~~~~~~~~~ SUMMARY ~~~~~~~~~~~~~~~~~~~~~~~~${ColourReset}")
message(STATUS "${BoldRed} General configuration of the msXpertSuite project ${ColourReset}")
message("")
message(STATUS "${BoldYellow}The system is detected by CMake as ${SYSTEM_UNAME_S}${ColourReset}")
message("")
message(STATUS "${BoldYellow}CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}${ColourReset}")
message("")
message(STATUS "${BoldRed}~~~~~~~~~~~~~~~~~~~~~~~~~~ massXpert ~~~~~~~~~~~~~~~~~~~~~~~~~~${ColourReset}")
message(STATUS "${BoldRed}~~~~~~~~~~~~~~~~~~~~~~~~~~ massXpert ~~~~~~~~~~~~~~~~~~~~~~~~~~${ColourReset}")
message(STATUS "${BoldYellow}MASSXPERT_BIN_DIR: ${MASSXPERT_BIN_DIR}${ColourReset}")
message(STATUS "${BoldYellow}MASSXPERT_JAVASCRIPT_DIR: ${MASSXPERT_JAVASCRIPT_DIR}${ColourReset}")
message(STATUS "${BoldYellow}MASSXPERT_DATA_DIR: ${MASSXPERT_DATA_DIR}${ColourReset}")
message(STATUS "${BoldYellow}MASSXPERT_DOC_DIR: ${MASSXPERT_DOC_DIR}${ColourReset}")
message("")
message(STATUS "${BoldRed}~~~~~~~~~~~~~~~~~~~~~~~~~~ mineXpert ~~~~~~~~~~~~~~~~~~~~~~~~~~${ColourReset}")
message(STATUS "${BoldRed}~~~~~~~~~~~~~~~~~~~~~~~~~~ mineXpert ~~~~~~~~~~~~~~~~~~~~~~~~~~${ColourReset}")
message(STATUS "${BoldYellow}MINEXPERT_BIN_DIR: ${MINEXPERT_BIN_DIR}${ColourReset}")
message(STATUS "${BoldYellow}MINEXPERT_JAVASCRIPT_DIR ${MINEXPERT_JAVASCRIPT_DIR}${ColourReset}")
message(STATUS "${BoldYellow}MINEXPERT_DATA_DIR: ${MINEXPERT_DATA_DIR}${ColourReset}")
message(STATUS "${BoldYellow}MINEXPERT_DOC_DIR: ${MINEXPERT_DOC_DIR}${ColourReset}")
message("")
if(PROFILE)
	message(STATUS "${BoldYellow}Profiling is requested (-DPROFILE=1)${ColourReset}")
else()
	message(STATUS "${BoldYellow}Profiling is NOT requested (-DPROFILE=0)${ColourReset}")
endif()
message("")
if(OPENMP)
	message(STATUS "${BoldYellow}OpenMP support is requested (-DOPENMP=1)${ColourReset}")
else()
	message(STATUS "${BoldYellow}OpenMP support is NOT requested (-DOPENMP=0)${ColourReset}")
endif()
message("")
if(WARNASERR)
	message(STATUS "${BoldYellow}Warnings treated as errors (-DWARNASERR=1)${ColourReset}")
else()
	message(STATUS "${BoldYellow}Warnings NOT treated as errors (-DWARNASERR=0)${ColourReset}")
endif()
message("")
if(CMAKE_BUILD_TYPE STREQUAL "debug")
	message(STATUS "${BoldYellow}Debug support requested (-DDEBUG=1)${ColourReset}")
else()
	message(STATUS "${BoldYellow}Debug support NOT requested (-DDEBUG=0)${ColourReset}")
endif()
message("")
message(STATUS "${BoldYellow}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")
message("")
message(STATUS "${BoldYellow}You can ask for clang++ by issuing the following command: $CXX=clang++ cmake -DOPENMP=1 -DDEBUG=1 ../development/${ColourReset}")
message(STATUS "${BoldYellow}The typical cmake invocation on mingw64 would be: cmake -DDEBUG=0 -DOPENMP=1 ../development/ -G'Unix Makefiles' -DCMAKE_CXX_COMPILER=/mingw64/bin/x86_64-w64-mingw32-g++.exe ${ColourReset}")
message(STATUS "${BoldYellow}The typical cmake invocation on Debian GNU/Linux would be: $cmake -DOPENMP=1 -DDEBUG=1 ../development${ColourReset}")
message("")
message(STATUS "${BoldYellow}The typical DeveloperMode cmake invocation on Debian GNU/Linux would be: $cmake -DOPENMP=1 -DDEBUG=1 -DDEVMODE=1 -DBUILD_USER_MANUALS=1 ../development${ColourReset}")
message("")
message(STATUS "${BoldYellow}To build the tests, add the -DTESTS=1 flag to the cmake command line: $cmake -DOPENMP=1 -DDEBUG=1 -DDEVMODE=1 -DBUILD_USER_MANUALS=1 -DTESTS=1 ../development${ColourReset}")
message("")
message(STATUS "${BoldRed}~~~~~~~~~~~~~~~~~~~~~~~~ SUMMARY ~~~~~~~~~~~~~~~~~~~~~~~~${ColourReset}")
message("")

=== doc/CMakeLists.txt ===
message("")
message(STATUS "${BoldGreen}Starting configuring of the doc material${ColourReset}")
message("")

# The UNIX man pages
if(UNIX AND NOT APPLE)

	message(STATUS "Going to generate the man pages.")

	execute_process(COMMAND docbook-to-man msxpertsuite.xml
		OUTPUT_FILE	${CMAKE_BINARY_DIR}/msxpertsuite.7
		WORKING_DIRECTORY	${CMAKE_CURRENT_SOURCE_DIR})

	execute_process(COMMAND docbook-to-man msxpertsuite-doc.xml
		OUTPUT_FILE	${CMAKE_BINARY_DIR}/msxpertsuite-doc.7
		WORKING_DIRECTORY	${CMAKE_CURRENT_SOURCE_DIR})

	execute_process(COMMAND docbook-to-man msxpertsuite-dev-doc.xml
		OUTPUT_FILE	${CMAKE_BINARY_DIR}/msxpertsuite-dev-doc.7
		WORKING_DIRECTORY	${CMAKE_CURRENT_SOURCE_DIR})

	execute_process(COMMAND docbook-to-man msxpertsuite-data.xml
		OUTPUT_FILE	${CMAKE_BINARY_DIR}/msxpertsuite-data.7
		WORKING_DIRECTORY	${CMAKE_CURRENT_SOURCE_DIR})

	execute_process(COMMAND docbook-to-man massxpert.xml
		OUTPUT_FILE	${CMAKE_BINARY_DIR}/massxpert.1
		WORKING_DIRECTORY	${CMAKE_CURRENT_SOURCE_DIR})

	execute_process(COMMAND docbook-to-man minexpert.xml
		OUTPUT_FILE	${CMAKE_BINARY_DIR}/minexpert.1
		WORKING_DIRECTORY	${CMAKE_CURRENT_SOURCE_DIR})

endif(UNIX AND NOT APPLE)


###############
# install stuff


if(NOT APPLE)
	# The history file (the html-formatted file is loaded dynamically by the
	# AboutDlg class and derived classes).
	install(FILES history.odt history.html readme.txt COPYING
		DESTINATION ${MASSXPERT_DOC_DIR})
	install(FILES history.odt history.html readme.txt COPYING
		DESTINATION ${MINEXPERT_DOC_DIR})
endif()

if(UNIX AND NOT APPLE)
	install(FILES ${CMAKE_BINARY_DIR}/msxpertsuite.7
		${CMAKE_BINARY_DIR}/msxpertsuite-doc.7
		${CMAKE_BINARY_DIR}/msxpertsuite-dev-doc.7
		${CMAKE_BINARY_DIR}/msxpertsuite-data.7
		DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man7)

	install(FILES ${CMAKE_BINARY_DIR}/massxpert.1
		${CMAKE_BINARY_DIR}/minexpert.1
		DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man1)
endif()

message("")
message(STATUS "${BoldGreen}Finished configuring of the doc material${ColourReset}")
message("")

=== globals/CMakeLists.txt ===
# Get the name of the current directory but with no path:
get_filename_component(TARGET ${CMAKE_CURRENT_BINARY_DIR} NAME)

message("")
message(STATUS "${BoldGreen}Start processing ${TARGET} dir.${ColourReset}")
message("")

########################################################
# Files

file(GLOB glob_SRCS *.cpp)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_BUILD_TYPE "release")
message("")
message(STATUS "${BoldGreen}Finished processing ${TARGET} dir.${ColourReset}")
message("")

=== libmass/CMakeLists.txt ===
set(CMAKE_COLOR_MAKEFILE ON)
set(CMAKE_VERBOSE_MAKEFILE ON)

# Get the name of the current directory but with no path:
get_filename_component(TARGET ${CMAKE_CURRENT_BINARY_DIR} NAME)

message("")
message(STATUS "${BoldGreen}Start processing ${TARGET} dir.${ColourReset}")
message("")

########################################################
# Files

file(GLOB mass_SRCS *.cpp)
file(GLOB glob_SRCS ../globals/*.cpp)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

if(SYSTEM_UNAME_S MATCHES "^MINGW.*")
	set(CMAKE_BUILD_TYPE "release")
else()
	set(CMAKE_BUILD_TYPE "debug")
endif()

find_package(Qt5 COMPONENTS Core Xml Svg Sql Script)

add_library(mass STATIC
	${mass_SRCS}
	${glob_SRCS})

qt5_use_modules(mass Xml)
qt5_use_modules(mass Svg)
qt5_use_modules(mass Sql)
qt5_use_modules(mass Script)

include_directories(
	# For the config file that is in the top binary dir.
	${CMAKE_BINARY_DIR}

	# For all the source subdirectories
	${CMAKE_SOURCE_DIR}

	${CMAKE_CURRENT_SOURCE_DIR}
	${CMAKE_CURRENT_BINARY_DIR}

	${Qt5Xml_INCLUDE_DIRS}
	${Qt5Svg_INCLUDE_DIRS}
	${Qt5Sql_INCLUDE_DIRS}
	${Qt5Script_INCLUDE_DIRS})


# On WIN64 we provide a number of libraries by our own, that we
# put in /usr/local/lib under /mingw64/.
if(WIN64)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -LC:/msys64/mingw64/usr/local/lib")
endif()


##############################################################
# libpwiz for reading mass spec data files,
message(STATUS "${BoldYellow}Link against the libpwiz library.${ColourReset}")
if(WIN64)
	include_directories("C:/msys64/mingw64/usr/local/include/pwiz")
elseif(APPLE)
	include_directories(/opt/local/include/pwiz)
	link_directories(/opt/local/lib/)
else()
	include_directories(/usr/include/pwiz)
endif()

set(required_target_link_libraries
	${required_target_link_libraries}
	pwiz)


##############################################################
# libboost_* on mingw
# On MINGW.* and mac we are our own provider of the boost libraries.
if(APPLE OR WIN64)

	message(STATUS "${BoldYellow}Link against the libboost libraries.${ColourReset}")

	if(WIN64)
	include_directories("${CMAKE_SOURCE_DIR}/../../boost/boost_1_56_0")
	elseif(APPLE)
		include_directories(/opt/local/include)
		include_directories(/opt/local/include/pwiz/libraries/boost_aux)
	endif()

	set(required_target_link_libraries
		${required_target_link_libraries}
		boost_chrono
		boost_filesystem
		boost_iostreams
		boost_program_options
		boost_serialization
		boost_system
		boost_thread
		z)
endif()


# Use the Widgets module from Qt 5. We craft a variable for this so as to
# transmit it directly to the tests subdirectory that will need it.
# Also, take the opportunity to ask for linking of the libgomp or lomp OPENMP
# library, depending on the compiler.

message(STATUS "${BoldYellow}Using parallelizing library ${OPENMP_LIBRARY}${ColourReset}")

set(required_target_link_libraries
	${required_target_link_libraries}
	Qt5::Xml
	Qt5::Svg
	Qt5::Sql
	Qt5::Script
	${OPENMP_LIBRARY})

# on MINGW.*, we'll need to add the -lstdc++ flag. Don't ask why.
if(SYSTEM_UNAME_S MATCHES "^MINGW.*")
	set(required_target_link_libraries
		${required_target_link_libraries}
		"stdc++")
endif()


#### Debugging stuff
message(STATUS required_target_link_libraries: ${required_target_link_libraries})
get_property(dirs DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY INCLUDE_DIRECTORIES)
foreach(dir ${dirs})
message(STATUS "included dir='${dir}'")
endforeach()

# Finally actually set the liking dependencies to the library.
target_link_libraries(mass
	${required_target_link_libraries})



message(STATUS "${TARGET} CMAKE_CURRENT_BINARY_DIR: ${CMAKE_CURRENT_BINARY_DIR}")
message(STATUS "Qt5Xml: " ${Qt5Xml_INCLUDE_DIRS})
message(STATUS "Qt5Svg: " ${Qt5Svg_INCLUDE_DIRS})
message(STATUS "Qt5Sql: " ${Qt5Sql_INCLUDE_DIRS})
message(STATUS "Using parallelizing library ${OPENMP_LIBRARY}")


message("")
message(STATUS "${BoldGreen}Finished processing ${TARGET} dir.${ColourReset}")
message("")

=== massxpert/CMakeLists.txt ===
set(CMAKE_COLOR_MAKEFILE ON)
set(CMAKE_VERBOSE_MAKEFILE ON)

if(APPLE)
	set(TARGET massXpert)
	message(STATUS "APPLE target name: ${TARGET}")
elseif(UNIX AND NOT APPLE)
	set(TARGET massxpert)
	message(STATUS "NON-APPLE target name: ${TARGET}")
elseif(WIN64)
	set(TARGET massXpert)
	message(STATUS "WIN64: ${TARGET}")
endif()

message("")
message(STATUS "${BoldGreen}Starting configuring of the ${TARGET} submodule${ColourReset}")
message("")

#############################################################
# Software configuration
message(STATUS "CMAKE_CURRENT_BINARY_DIR: " ${CMAKE_CURRENT_BINARY_DIR})

########################################################
# Files
file(GLOB MASSXPERT_nongui_SRCS nongui/*.cpp)
file(GLOB MASSXPERT_gui_SRCS gui/*.cpp)
file(GLOB MASSXPERT_SRCS *.cpp)
file(GLOB MASSXPERT_UIS gui/ui/*.ui)

# The desktop file
if(UNIX AND NOT APPLE)
	install(FILES org.msxpertsuite.massxpert.desktop
		DESTINATION ${CMAKE_INSTALL_PREFIX}/share/applications)
endif()

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

find_package(Qt5 COMPONENTS Widgets Xml Svg Sql Script)

qt5_wrap_ui(MASSXPERT_UIS_H ${MASSXPERT_UIS})

qt5_add_resources(MASSXPERT_QRC_CPP gui/application.qrc)

### These two lines required because now CMake only automocs
### the generated files and not the source files.
set_source_files_properties(${MASSXPERT_UIS_H} PROPERTIES SKIP_AUTOMOC ON)
set_source_files_properties(${MASSXPERT_QRC_CPP} PROPERTIES SKIP_AUTOMOC ON)


###############################################################
# Configuration of the binary to be built
###############################################################

if(NOT APPLE)
	add_executable(${TARGET}
		${MASSXPERT_nongui_SRCS}
		${MASSXPERT_gui_SRCS}
		${MASSXPERT_SRCS}
		${MASSXPERT_UIS_H}
		${MASSXPERT_QRC_CPP})
else()

	# Copy the icon file to the Contents/Resources directory of the bundle at
	# location ${MACOSX_PACKAGE_LOCATION}.
	set_source_files_properties(../images/msXpertSuite.icns PROPERTIES MACOSX_PACKAGE_LOCATION Resources)

	# Identify MacOS bundle

	set(MACOSX_BUNDLE_BUNDLE_NAME ${TARGET})
	message(STATUS "MACOSX_BUNDLE_BUNDLE_NAME: ${MACOSX_BUNDLE_BUNDLE_NAME}")

	set(MACOSX_BUNDLE_BUNDLE_VERSION ${PROJECT_VERSION})
	set(MACOSX_BUNDLE_LONG_VERSION_STRING ${PROJECT_VERSION})
	set(MACOSX_BUNDLE_SHORT_VERSION_STRING ${PROJECT_VERSION})
	set(MACOSX_BUNDLE_COPYRIGHT ${COPYRIGHT})
	set(MACOSX_BUNDLE_GUI_IDENTIFIER ${IDENTIFIER})
	set(MACOSX_BUNDLE_ICON_FILE ../images/msXpertSuite.icns)

	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mmacosx-version-min=10.9"
		CACHE STRING "Flags used by the compiler during all build types." FORCE)

	#set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility-inlines-hidden"
	#CACHE STRING "Flags used by the compiler during all build types." FORCE)

	set(CMAKE_OSX_SYSROOT "/Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/MacOSX10.12.sdk/"
		CACHE STRING "MacOSX10.12.sdk." FORCE)

	add_executable(${TARGET} MACOSX_BUNDLE
		${MASSXPERT_nongui_SRCS}
		${MASSXPERT_gui_SRCS}
		${MASSXPERT_SRCS}
		${MASSXPERT_UIS_H}
		${MASSXPERT_QRC_CPP}
		../images/msXpertSuite.icns
		)

	set_target_properties(${TARGET} PROPERTIES MACOSX_BUNDLE_ICON_FILE msXpertSuite.icns)

endif()


###############################################################
# Installation directories depending on the platform and module
###############################################################

if(WIN64)
	set(CMAKE_INSTALL_PREFIX "C:/Program Files/msXpertSuite")
	set(MASSXPERT_BIN_DIR ${CMAKE_INSTALL_PREFIX})
	set(MASSXPERT_JAVASCRIPT_DIR ${CMAKE_INSTALL_PREFIX}/javascript/massxpert)
	set(MASSXPERT_DATA_DIR ${CMAKE_INSTALL_PREFIX}/data/massxpert)
	set(MASSXPERT_DOC_DIR ${CMAKE_INSTALL_PREFIX}/doc/massxpert)
elseif(UNIX AND NOT APPLE)
	set(MASSXPERT_BIN_DIR ${CMAKE_INSTALL_PREFIX}/bin)
	set(MASSXPERT_JAVASCRIPT_DIR ${CMAKE_INSTALL_PREFIX}/share/msxpertsuite-massxpert/javascript)
	set(MASSXPERT_DATA_DIR ${CMAKE_INSTALL_PREFIX}/share/msxpertsuite-massxpert/data)
	set(MASSXPERT_DOC_DIR ${CMAKE_INSTALL_PREFIX}/share/doc/msxpertsuite-massxpert/doc)
elseif(APPLE)
	SET (BUNDLE_DIR ${CMAKE_CURRENT_BINARY_DIR}/massXpert.app)
	SET(CMAKE_INSTALL_PREFIX "${BUNDLE_DIR}/Contents")
	SET (MASSXPERT_BIN_DIR ${BUNDLE_DIR}/Contents/MacOS)
	SET (MASSXPERT_JAVASCRIPT_DIR ${BUNDLE_DIR}/Contents/Resources/massxpert/javascript)
	SET (MASSXPERT_DATA_DIR ${BUNDLE_DIR}/Contents/Resources/massxpert/data)
	SET (MASSXPERT_DOC_DIR ${BUNDLE_DIR}/Contents/Resources/massxpert/doc)
endif()

message(STATUS "CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "MASSXPERT_BIN_DIR: ${MASSXPERT_BIN_DIR}")
message(STATUS "MASSXPERT_JAVASCRIPT_DIR: ${MASSXPERT_JAVASCRIPT_DIR}")
message(STATUS "MASSXPERT_DATA_DIR: ${MASSXPERT_DATA_DIR}")
message(STATUS "MASSXPERT_DOC_DIR: ${MASSXPERT_DOC_DIR}")

# Prepare various directory names for the parent directory to use later.
set_directory_properties(PROPERTIES CMAKE_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
set_directory_properties(PROPERTIES MASSXPERT_TARGET_NAME ${TARGET})
set_directory_properties(PROPERTIES MASSXPERT_BIN_DIR ${MASSXPERT_BIN_DIR})
set_directory_properties(PROPERTIES MASSXPERT_JAVASCRIPT_DIR ${MASSXPERT_JAVASCRIPT_DIR})
set_directory_properties(PROPERTIES MASSXPERT_DATA_DIR ${MASSXPERT_DATA_DIR})
set_directory_properties(PROPERTIES MASSXPERT_DOC_DIR ${MASSXPERT_DOC_DIR})

qt5_use_modules(${TARGET} Widgets)
qt5_use_modules(${TARGET} Xml)
qt5_use_modules(${TARGET} Svg)
qt5_use_modules(${TARGET} Sql)
qt5_use_modules(${TARGET} Script)
qt5_use_modules(${TARGET} PrintSupport)

include_directories(

	# The config file is binary directory-specific !!!
	# For the config.h file generated from config.h.in
	# For the ui_Xyyyyy.h files
	${CMAKE_CURRENT_BINARY_DIR}

	# For all the source subdirectories
	${CMAKE_SOURCE_DIR}

	${CMAKE_BINARY_DIR}/libmassgui

	${Qt5Widgets_INCLUDE_DIRS}
	${Qt5Xml_INCLUDE_DIRS}
	${Qt5Svg_INCLUDE_DIRS}
	${Qt5Sql_INCLUDE_DIRS}
	${Qt5Script_INCLUDE_DIRS}
	${Qt5PrintSupport_INCLUDE_DIRS})


# On GNU/Linux, make sure we have the QCustomPlot library
# installed on the system (on MINGW, we have the
# source files (see above).
if(NOT WIN64 AND NOT APPLE)

	find_package(QCustomPlot)

	if(NOT QCustomPlot_FOUND)
		message(FATAL_ERROR "QCustomPlot not found!")
	else()
		message(STATUS "QCustomPlot found!")
	endif()

endif()

# Now handle the private libraries for non-gui stuff (libmass.a) and gui stuff
# (libmassgui.a)
if(APPLE)

	set(MASSLIB "${CMAKE_BINARY_DIR}/libmass/libmass.a")
	set(MASSGUILIB "${CMAKE_BINARY_DIR}/libmassgui/libmassgui.a")

else()

	set(MASSLIB "-Wl,-whole-archive ${CMAKE_BINARY_DIR}/libmass/libmass.a -Wl,-no-whole-archive")
	set(MASSGUILIB "-Wl,-whole-archive ${CMAKE_BINARY_DIR}/libmassgui/libmassgui.a -Wl,-no-whole-archive")

endif()

message(STATUS "libdir: ${CMAKE_BINARY_DIR}/libmass/libmass.a")
message(STATUS "guilibdir: ${CMAKE_BINARY_DIR}/libmassgui/libmassgui.a")

message(STATUS "Using parallelizing library ${OPENMP_LIBRARY}")

set(required_target_link_libraries
	${MASSLIB}
	${MASSGUILIB}
	${OPENMP_LIBRARY}
	Qt5::Widgets
	Qt5::Xml
	Qt5::Svg
	Qt5::Sql
	Qt5::Script
	Qt5::PrintSupport)


# On WIN64 we provide a number of libraries by our own, that we
# put in /usr/local/lib under /mingw64/.
if(WIN64)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -LC:/msys64/mingw64/usr/local/lib")
endif()


##############################################################
# libpwiz for reading mass spec data files,
message(STATUS "${BoldYellow}Link against the libpwiz library.${ColourReset}")
if(WIN64)
	include_directories("C:/msys64/mingw64/usr/local/include/pwiz")
elseif(APPLE)
	include_directories(/opt/local/include/pwiz)
	link_directories(/opt/local/lib)
else()
	include_directories(/usr/include/pwiz)
endif()

set(required_target_link_libraries
	${required_target_link_libraries}
	pwiz)

##############################################################
# libboost_* on mingw
# On MINGW.* we are our own provider of the boost libraries.
if(WIN64)

	message(STATUS "${BoldYellow}Link against the libboost libraries.${ColourReset}")

	include_directories("${CMAKE_SOURCE_DIR}/../../boost/boost_1_56_0")

	set(required_target_link_libraries
		${required_target_link_libraries}
		boost_chrono
		boost_filesystem
		boost_iostreams
		boost_program_options
		boost_serialization
		boost_system
		boost_thread
		z)

elseif(APPLE)
	# With macport
	include_directories("/opt/local/include")
	link_directories("/opt/local/lib")

	set(required_target_link_libraries
		${required_target_link_libraries}
		boost_chrono-mt
		boost_filesystem-mt
		boost_iostreams-mt
		boost_program_options-mt
		boost_serialization-mt
		boost_system-mt
		boost_thread-mt
		z)

endif()

# On MINGW.*, we'll need to add the -lstdc++ flag. Don't ask why.
if(WIN64)

	set(required_target_link_libraries
		${required_target_link_libraries}
		"stdc++")

endif()

# When on UNIX/NOT APPLE we can make use the system-wide qcustomplot library.
if(UNIX AND NOT APPLE)

	set(required_target_link_libraries
		${required_target_link_libraries}
		"qcustomplot")

endif()


#### Debugging stuff
#message(STATUS required_target_link_libraries: ${required_target_link_libraries})

#message(STATUS "Now printing all the include directories -I...")

#get_property(dirs DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY INCLUDE_DIRECTORIES)
#foreach(dir ${dirs})
	#message(STATUS "included dir='${dir}'")
#endforeach()

#message(STATUS "Now printing all the linking directories -L...")

#get_property(dirs DIRECTORY PROPERTY LINK_DIRECTORIES)
#foreach(dir ${dirs})
	#message(STATUS "link directory dir='${dir}'")
#endforeach()

# Finally actually set the linking dependencies to the executable.
target_link_libraries(${TARGET}
	${required_target_link_libraries})


# Add an explicit dependency to libmass and libmassgui so that when invoking
# make from inside the massxpert bin build dir, the dependencies get built.
add_dependencies(${TARGET} mass massgui)


if(PROFILE)
	message(STATUS "Profiling is requested, adding linker -pg flag.")
	set (CMAKE_EXE_LINKER_FLAGS "-pg")
endif()


if(NOT APPLE)
	# We want to install the binary arch-dependent target in
	# specific situations. To have proper control, we define the arch
	# component.
	install(TARGETS ${TARGET}
		RUNTIME
		COMPONENT arch
		DESTINATION ${MASSXPERT_BIN_DIR})
endif()


#############################################################
###################
# BUILD OF THE DATA

#################
# process subdirs
add_subdirectory(data)


#############################################################
##########################
# BUILD OF THE USER MANUAL

message(STATUS "massXpert User Manual to be built")
add_subdirectory(user-manual)


message("")
message(STATUS "${BoldGreen}Finished configuring of the massXpert submodule.${ColourReset}")
message("")

=== minexpert/CMakeLists.txt ===
# Get the name of the current directory but with no path:
#get_filename_component(TARGET ${CMAKE_CURRENT_BINARY_DIR} NAME)

# ${TARGET}-objlib will be the name of the object files collection (in CMake
# parlance that is an "OBJECT" library type. In that library, that is simply a
# list of compiled object files, I put all the *.o files that make the ${TARGET}
# (minexpert or massxpert) executable image file, but not main.cpp. This is done
# because when building the tests/tests binary for tests relating to ${TARGET},
# I'll reuse these compiled object files.

if(APPLE)
	set(TARGET mineXpert)
	message(STATUS "APPLE: ${TARGET}")
elseif(UNIX AND NOT APPLE)
	set(TARGET minexpert)
	message(STATUS "NON-APPLE: ${TARGET}")
elseif(WIN64)
	set(TARGET mineXpert)
	message(STATUS "WIN64: ${TARGET}")
endif()

message("")
message(STATUS "${BoldGreen}Starting configuring of the ${TARGET} submodule${ColourReset}")
message("")


#############################################################
# Software configuration
message(STATUS "CMAKE_CURRENT_BINARY_DIR: " ${CMAKE_CURRENT_BINARY_DIR})

########################################################
# Files
file(GLOB MINEXPERT-objlib_nongui_SRCS nongui/*.cpp)
file(GLOB MINEXPERT-objlib_gui_SRCS gui/*.cpp)
file(GLOB MINEXPERT-objlib_UIS gui/ui/*.ui)

# The only file that does not enter in the object library of
# object files (see notice above).
file(GLOB MINEXPERT-exec_SRCS main.cpp)

# The desktop file
if(UNIX AND NOT APPLE)
	install(FILES org.msxpertsuite.minexpert.desktop
		DESTINATION ${CMAKE_INSTALL_PREFIX}/share/applications)
endif()

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

find_package(Qt5 COMPONENTS Widgets Xml Svg Sql Script PrintSupport)

qt5_wrap_ui(MINEXPERT-objlib_UIS_H ${MINEXPERT-objlib_UIS})

qt5_add_resources(MINEXPERT_QRC_CPP gui/application.qrc)

### These two lines required because now CMake only automocs
### the generated files and not the source files.
set_source_files_properties(${MINEXPERT-objlib_UIS_H} PROPERTIES SKIP_AUTOMOC ON)
set_source_files_properties(${MINEXPERT_QRC_CPP} PROPERTIES SKIP_AUTOMOC ON)


add_library(MINEXPERT-objlib OBJECT
	${MINEXPERT-objlib_nongui_SRCS}
	${MINEXPERT-objlib_gui_SRCS}
	${MINEXPERT-objlib_UIS_H})

###############################################################
# Configuration of the binary to be built
###############################################################

# Now we can only add the executable, because we have defined the sources of the
# object library above.

if(NOT APPLE)
	add_executable(${TARGET}
		${MINEXPERT-exec_SRCS}
		$<TARGET_OBJECTS:MINEXPERT-objlib>
		${MINEXPERT_QRC_CPP})
else()

	# Copy the icon file to the Contents/Resources directory of the bundle at
	# location ${MACOSX_PACKAGE_LOCATION}.
	set_source_files_properties(../images/msXpertSuite.icns PROPERTIES MACOSX_PACKAGE_LOCATION Resources)

	# Identify MacOS bundle

	set(MACOSX_BUNDLE_BUNDLE_NAME ${TARGET})
	message(STATUS "MACOSX_BUNDLE_BUNDLE_NAME: ${MACOSX_BUNDLE_BUNDLE_NAME}")

	set(MACOSX_BUNDLE_BUNDLE_VERSION ${PROJECT_VERSION})
	set(MACOSX_BUNDLE_LONG_VERSION_STRING ${PROJECT_VERSION})
	set(MACOSX_BUNDLE_SHORT_VERSION_STRING ${PROJECT_VERSION})
	set(MACOSX_BUNDLE_COPYRIGHT ${COPYRIGHT})
	set(MACOSX_BUNDLE_GUI_IDENTIFIER ${IDENTIFIER})
	set(MACOSX_BUNDLE_ICON_FILE ../images/msXpertSuite.icns)

	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mmacosx-version-min=10.9"
		CACHE STRING "Flags used by the compiler during all build types." FORCE)

	#set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility-inlines-hidden"
	#CACHE STRING "Flags used by the compiler during all build types." FORCE)

	set(CMAKE_OSX_SYSROOT "/Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/MacOSX10.12.sdk/"
		CACHE STRING "MacOSX10.12.sdk." FORCE)

	add_executable(${TARGET} MACOSX_BUNDLE
		${MINEXPERT-exec_SRCS}
		$<TARGET_OBJECTS:MINEXPERT-objlib>
		${MINEXPERT_QRC_CPP}
		../images/msXpertSuite.icns
		)

	set_target_properties(${TARGET} PROPERTIES MACOSX_BUNDLE_ICON_FILE msXpertSuite.icns)

endif()


###############################################################
# Installation directories depending on the platform and module
###############################################################

if(WIN64)
	set(CMAKE_INSTALL_PREFIX "C:/Program Files/msXpertSuite")
	set(MINEXPERT_BIN_DIR ${CMAKE_INSTALL_PREFIX})
	set(MINEXPERT_JAVASCRIPT_DIR ${CMAKE_INSTALL_PREFIX}/javascript/minexpert)
	set(MINEXPERT_DATA_DIR ${CMAKE_INSTALL_PREFIX}/data/minexpert)
	set(MINEXPERT_DOC_DIR ${CMAKE_INSTALL_PREFIX}/doc/minexpert)
elseif(UNIX AND NOT APPLE)
	set(MINEXPERT_BIN_DIR ${CMAKE_INSTALL_PREFIX}/bin)
	set(MINEXPERT_JAVASCRIPT_DIR ${CMAKE_INSTALL_PREFIX}/share/msxpertsuite-minexpert/javascript)
	set(MINEXPERT_DATA_DIR ${CMAKE_INSTALL_PREFIX}/share/msxpertsuite-minexpert/data)
	set(MINEXPERT_DOC_DIR ${CMAKE_INSTALL_PREFIX}/share/doc/msxpertsuite-minexpert/doc)
elseif(APPLE)
	SET (BUNDLE_DIR ${CMAKE_CURRENT_BINARY_DIR}/mineXpert.app)
	SET(CMAKE_INSTALL_PREFIX "${BUNDLE_DIR}/Contents")
	SET (MINEXPERT_BIN_DIR ${BUNDLE_DIR}/Contents/MacOS)
	SET (MINEXPERT_JAVASCRIPT_DIR ${BUNDLE_DIR}/Contents/Resources/minexpert/javascript)
	SET (MINEXPERT_DATA_DIR ${BUNDLE_DIR}/Contents/Resources/minexpert/data)
	SET (MINEXPERT_DOC_DIR ${BUNDLE_DIR}/Contents/Resources/minexpert/doc)
endif()

message(STATUS "CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "MINEXPERT_BIN_DIR: ${MINEXPERT_BIN_DIR}")
message(STATUS "MINEXPERT_JAVASCRIPT_DIR ${MINEXPERT_JAVASCRIPT_DIR}")
message(STATUS "MINEXPERT_DATA_DIR: ${MINEXPERT_DATA_DIR}")
message(STATUS "MINEXPERT_DOC_DIR: ${MINEXPERT_DOC_DIR}")

# Prepare various directory names for the parent directory to use later.
set_directory_properties(PROPERTIES CMAKE_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
set_directory_properties(PROPERTIES MINEXPERT_TARGET_NAME ${TARGET})
set_directory_properties(PROPERTIES MINEXPERT_BIN_DIR ${MINEXPERT_BIN_DIR})
set_directory_properties(PROPERTIES MINEXPERT_JAVASCRIPT_DIR ${MINEXPERT_JAVASCRIPT_DIR})
set_directory_properties(PROPERTIES MINEXPERT_DATA_DIR ${MINEXPERT_DATA_DIR})
set_directory_properties(PROPERTIES MINEXPERT_DOC_DIR ${MINEXPERT_DOC_DIR})


###############################################################
# JavaScript material
###############################################################

add_subdirectory(javascript)

qt5_use_modules(${TARGET} Widgets)
qt5_use_modules(${TARGET} Xml)
qt5_use_modules(${TARGET} Svg)
qt5_use_modules(${TARGET} Sql)
qt5_use_modules(${TARGET} Script)
qt5_use_modules(${TARGET} PrintSupport)

include_directories(

	# The config file is binary directory-specific !!!
	# For the config.h file generated from config.h.in
	# For the ui_Xyyyyy.h files
	${CMAKE_CURRENT_BINARY_DIR}

	# For all the source subdirectories
	${CMAKE_SOURCE_DIR}

	${CMAKE_BINARY_DIR}/libmassgui

	${Qt5Widgets_INCLUDE_DIRS}
	${Qt5Xml_INCLUDE_DIRS}
	${Qt5Svg_INCLUDE_DIRS}
	${Qt5Sql_INCLUDE_DIRS}
	${Qt5Script_INCLUDE_DIRS}
	${Qt5PrintSupport_INCLUDE_DIRS})


# On GNU/Linux, make sure we have the QCustomPlot library
# installed on the system (on MINGW, we have the
# source files (see above).
if(NOT WIN64 AND NOT APPLE)

	find_package(QCustomPlot)

	if(NOT QCustomPlot_FOUND)
		message(FATAL_ERROR "QCustomPlot not found!")
	else()
		message(STATUS "QCustomPlot found!")
	endif()

endif()

# Now handle the private libraries for non-gui stuff (libmass.a) and gui stuff
# (libmassgui.a)
if(APPLE)

	set(MASSLIB "${CMAKE_BINARY_DIR}/libmass/libmass.a")
	set(MASSGUILIB "${CMAKE_BINARY_DIR}/libmassgui/libmassgui.a")

else()

	set(MASSLIB "-Wl,-whole-archive ${CMAKE_BINARY_DIR}/libmass/libmass.a -Wl,-no-whole-archive")
	set(MASSGUILIB "-Wl,-whole-archive ${CMAKE_BINARY_DIR}/libmassgui/libmassgui.a -Wl,-no-whole-archive")

endif()

message(STATUS "libdir: ${CMAKE_BINARY_DIR}/libmass/libmass.a")
message(STATUS "guilibdir: ${CMAKE_BINARY_DIR}/libmassgui/libmassgui.a")

message(STATUS "Using parallelizing library ${OPENMP_LIBRARY}")

set(required_target_link_libraries
	${MASSLIB}
	${MASSGUILIB}
	${OPENMP_LIBRARY}
	Qt5::Widgets
	Qt5::Xml
	Qt5::Svg
	Qt5::Sql
	Qt5::Script
	Qt5::PrintSupport)


# On WIN64 we provide a number of libraries by our own, that we
# put in /usr/local/lib under /mingw64/.
if(WIN64)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -LC:/msys64/mingw64/usr/local/lib")
endif()


##############################################################
# libpwiz for reading mass spec data files,
message(STATUS "${BoldYellow}Link against the libpwiz library.${ColourReset}")
if(WIN64)
	include_directories("C:/msys64/mingw64/usr/local/include/pwiz")
elseif(APPLE)
	include_directories("/opt/local/include/pwiz")
	link_directories("/opt/local/lib")
else()
	include_directories("/usr/include/pwiz")
endif()

set(required_target_link_libraries
	${required_target_link_libraries}
	pwiz)

##############################################################
# libboost_* on mingw
# On MINGW.* we are our own provider of the boost libraries.
if(WIN64)

	message(STATUS "${BoldYellow}Link against the libboost libraries.${ColourReset}")

	include_directories("${CMAKE_SOURCE_DIR}/../../boost/boost_1_56_0")

	set(required_target_link_libraries
		${required_target_link_libraries}
		boost_chrono
		boost_filesystem
		boost_iostreams
		boost_program_options
		boost_serialization
		boost_system
		boost_thread
		z)

elseif(APPLE)
	# With macport
	include_directories("/opt/local/include")
	# Attention #####
	# below for
	# /opt/local/include/pwiz/libraries/boost_aux/boost/utility/singleton.hpp
	include_directories("/opt/local/include/pwiz/libraries/boost_aux")
	link_directories("/opt/local/lib")

	set(required_target_link_libraries
		${required_target_link_libraries}
		boost_chrono-mt
		boost_filesystem-mt
		boost_iostreams-mt
		boost_program_options-mt
		boost_serialization-mt
		boost_system-mt
		boost_thread-mt
		z)

endif()

# On MINGW.*, we'll need to add the -lstdc++ flag. Don't ask why.
if(WIN64)

	set(required_target_link_libraries
		${required_target_link_libraries}
		"stdc++")

endif()

# When on UNIX/NOT APPLE we can make use the system-wide qcustomplot library.
if(UNIX AND NOT APPLE)

	set(required_target_link_libraries
		${required_target_link_libraries}
		"qcustomplot")

endif()


#### Debugging stuff
#message(STATUS required_target_link_libraries: ${required_target_link_libraries})

#message(STATUS "Now printing all the include directories -I...")

#get_property(dirs DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY INCLUDE_DIRECTORIES)
#foreach(dir ${dirs})
	#message(STATUS "included dir='${dir}'")
#endforeach()

#message(STATUS "Now printing all the linking directories -L...")

#get_property(dirs DIRECTORY PROPERTY LINK_DIRECTORIES)
#foreach(dir ${dirs})
	#message(STATUS "link directory dir='${dir}'")
#endforeach()

# Finally actually set the linking dependencies to the executable.
target_link_libraries(${TARGET}
	${required_target_link_libraries})


# Add an explicit dependency to libmass and libmassgui so that when invoking
# make from inside the massxpert bin build dir, the dependencies get built.
add_dependencies(${TARGET} mass massgui)

if(PROFILE)
	message(STATUS "Profiling is requested, adding linker -pg flag.")
	set (CMAKE_EXE_LINKER_FLAGS "-pg")
endif()

if(NOT APPLE)
	# We want to install the binary arch-dependent target in
	# specific situations. To have proper control, we define the arch
	# component.
	install(TARGETS ${TARGET}
		RUNTIME
		COMPONENT arch
		DESTINATION ${MINEXPERT_BIN_DIR})
endif()


#############################################################
##########################
# EXTRACTION OF THE JAVASCRIPT-RELATED DOCUMENTATION FROM THE SOURCE FILES

if(UNIX AND NOT APPLE)
	if(DEVMODE)

		message(STATUS "mineXpert: extracting JavaScript-related documentation")
		execute_process(COMMAND devdoc/scripts/jsExtract.py -i libmass/DataPointJs.cpp
			libmass/DataPointJsPrototype.cpp
			minexpert/nongui/SavGolParamsJSDoc.cpp

=== tests/CMakeLists.txt ===
# Get the name of the current directory but with no path:
get_filename_component(PATHNAME ${CMAKE_CURRENT_BINARY_DIR} ABSOLUTE)

message("")
message(STATUS "${BoldGreen}Start processing ${PATHNAME} dir.${ColourReset}")
message("")

set(TARGET tests)

########################################################
# Files

# We use the object file collection system of CMake (they call the library an
# "OBJECT" library type). The list of compiled object files from minexpert are
# stored in $<TARGET_OBJECTS:minexpert-objlib>. We use that identifier so as to
# avoid recompilation of the files for the testing purpose.

# But we also have the source files of the tests, these files are distributed
# among the various directories : src/libmass and src/minexpert at the moment.

file(GLOB ${TARGET}_libmassTest_SRCS
	src/libmass/*.cpp)

file(GLOB ${TARGET}_minexpertTest_SRCS
	src/minexpert/*.cpp)

set(SRCTEST
	src/testmain.cpp
	${${TARGET}_minexpertTest_SRCS}
	${${TARGET}_libmassTest_SRCS})

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

find_package(Qt5 COMPONENTS Widgets Xml Svg Sql Script)

qt5_wrap_ui(${TARGET}_UIS_H ${${TARGET}_UIS})

qt5_add_resources(${TARGET}QRC_CPP gui/application.qrc)

add_executable(${TARGET}
	${SRCTEST}
	$<TARGET_OBJECTS:minexpert-objlib>)

target_compile_definitions(${TARGET} PRIVATE TESTS) #add -DTESTS
set_property(TARGET ${TARGET} PROPERTY CXX_STANDARD 14) # we want C++14

qt5_use_modules(${TARGET} Widgets)
qt5_use_modules(${TARGET} Xml)
qt5_use_modules(${TARGET} Svg)
qt5_use_modules(${TARGET} Sql)
qt5_use_modules(${TARGET} Script)
qt5_use_modules(${TARGET} PrintSupport)

include_directories(
	# For the config.h file generated from config.h.in	
	${CMAKE_BINARY_DIR}

	# For the globals/globals.hpp inclusion
	${CMAKE_SOURCE_DIR}

	${CMAKE_SOURCE_DIR}/libmass
	${CMAKE_SOURCE_DIR}/libmassgui
	${CMAKE_SOURCE_DIR}/minexpert/nongui
	${CMAKE_SOURCE_DIR}/minexpert/gui

	${CMAKE_BINARY_DIR}/libmass
	${CMAKE_BINARY_DIR}/libmassgui

	# For the ui_Xyyyyy.h files of both modules.
	${CMAKE_BINARY_DIR}/massxpert
	${CMAKE_BINARY_DIR}/minexpert

	${CMAKE_CURRENT_SOURCE_DIR}

	${Qt5Widgets_INCLUDE_DIRS}
	${Qt5Xml_INCLUDE_DIRS}
	${Qt5Svg_INCLUDE_DIRS}
	${Qt5Sql_INCLUDE_DIRS}
	${Qt5Script_INCLUDE_DIRS}
	${Qt5PrintSupport_INCLUDE_DIRS}
	/usr/include/pwiz
	)

target_include_directories(${TARGET} PRIVATE
	${INCLUDE_DIRECTORIES}
	)


# Now handle the private libraries for non-gui stuff (libmass.a) and gui stuff
# (libmassgui.a)
set(MASSLIB -Wl,-whole-archive ${CMAKE_BINARY_DIR}/libmass/libmass.a -Wl,-no-whole-archive)
set(MASSGUILIB -Wl,-whole-archive ${CMAKE_BINARY_DIR}/libmassgui/libmassgui.a -Wl,-no-whole-archive)

set(required_target_link_libraries
	${MASSLIB}
	${MASSGUILIB}
	${OPENMP_LIBRARY}	
	Qt5::Widgets
	Qt5::Xml
	Qt5::Svg
	Qt5::Sql
	Qt5::Script
	Qt5::PrintSupport
	"qcustomplot"
	pwiz)

### Debugging stuff
#message(STATUS required_target_link_libraries: ${required_target_link_libraries})
#get_property(dirs DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY INCLUDE_DIRECTORIES)
#foreach(dir ${dirs})
#message(STATUS "included dir='${dir}'")
#endforeach()

target_link_libraries(${TARGET}
	${required_target_link_libraries})

# Add an explicit dependency to libmass and libmassgui so that when invoking
# make from inside the massxpert bin build dir, the dependencies get built.
add_dependencies(${TARGET} mass massgui)

message("")
message(STATUS "${BoldGreen}Finished processing ${PATHNAME} dir.${ColourReset}")
message("")

=== massxpert/user-manual/CMakeLists.txt ===
message(STATUS "\nStarting configuring of the massxpert-user-manual material\n")

#############################################################
# There are warning issued during the compilation of almost
# any LaTeX source, but we want the compilation not to stop...
# Because the build process has -Werror set globally we want to
# disable it here specifically.
if(PEDANTIC)
  REMOVE_DEFINITIONS (-Werror)
endif(PEDANTIC)

if(UNIX AND NOT APPLE)

  set(CUR_DOC_DIR ${CMAKE_SOURCE_DIR}/massxpert/user-manual)
  set(CUR_DOC_BUILD_DIR ${CMAKE_CURRENT_BINARY_DIR}/build-user-manual)

  message(STATUS "Current doc directory: ${CUR_DOC_DIR}")
  message(STATUS "Current doc build directory: ${CUR_DOC_BUILD_DIR}")

  # Copy the directory to a build directory. This will also copy as "hard"
  # files, following the various symbolic links,  to other files in other places
  # in the source tree (preface.tex is an example, images/splashscreen.png or
  # images/addresses.png are two other examples; the files in
  # user-manual-common/figures that are linked in the local figures directory
  # also).
  execute_process(COMMAND cp -rpL ${CUR_DOC_DIR} ${CUR_DOC_BUILD_DIR}
    WORKING_DIRECTORY	${CMAKE_CURRENT_BINARY_DIR})

  # Make sure we use the Makefile that is located in the new directory, copy 
  # of the original user-manual directory. 
  add_custom_command(OUTPUT massxpert-doc.pdf
    COMMAND make -f ${CUR_DOC_BUILD_DIR}/Makefile usermanual
    WORKING_DIRECTORY ${CUR_DOC_BUILD_DIR}
    COMMENT "LaTeX-build the massXpert user manual")

  if(BUILD_USER_MANUALS)

    # Command:
    # make massxpert-user-manual
    add_custom_target(massxpert-user-manual ALL
      DEPENDS massxpert-doc.pdf
      COMMENT "Make massxpert-user-manual")

    # Command:
    # make copy-massxpert-doc.pdf
    add_custom_target(copy-massxpert-doc.pdf ALL
      COMMAND ${CMAKE_COMMAND} -E copy ${CUR_DOC_BUILD_DIR}/massxpert-doc.pdf
      ${CMAKE_SOURCE_DIR}/massxpert/user-manual
      DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/massxpert-doc.pdf
      COMMENT "Copy the pdf file to the source doc dir.")

  endif()

endif()

if(PEDANTIC)
  ADD_DEFINITIONS (-Werror)
endif(PEDANTIC)

if(UNIX AND NOT APPLE)

install(FILES ${CUR_DOC_BUILD_DIR}/massxpert-doc.pdf 
	DESTINATION ${MASSXPERT_DOC_DIR})

elseif(APPLE)

	install(FILES ${CMAKE_SOURCE_DIR}/massxpert/user-manual/massxpert-doc.pdf
		DESTINATION ${MASSXPERT_DOC_DIR})

endif()

message(STATUS "\nFinished configuring of the massxpert-user-manual material.\n")

=== massxpert/user-manual/Makefile ===
PROJECT=massxpert-doc
okularPid=$(shell cat okular.pid)

PAPER=$(PROJECT).tex  # set the path to your TeX file here

SHELL=/bin/bash   # for the while loop below

noreader: 
	echo "make noreader"
	pdflatex --interaction nonstopmode -halt-on-error -file-line-error $(PAPER) && \
		pdflatex --interaction nonstopmode -halt-on-error -file-line-error $(PAPER)
	if [ -f $(PROJECT).idx ] ; \
		then \
		makeindex $(PROJECT).idx ; \
		fi
	pdflatex --interaction nonstopmode -halt-on-error -file-line-error $(PAPER) && \
		pdflatex --interaction nonstopmode -halt-on-error -file-line-error $(PAPER)
	touch noreader

.PHONY: usermanual
usermanual: noreader
# echo "make usermanual"

all:  ## Compile paper
	echo "make all"
	rubber --pdf $(PAPER); /usr/bin/test "$$?" -eq 0
	qdbus org.kde.okular-$(shell cat okular.pid) /okular reload

clean:  ## Clean output files
	echo "make clean"
	rm -f noreader
	rubber --clean $(PAPER)

watch:  ## Recompile on updates to the source file
	while [ 1 ]; do; inotifywait $(PAPER); sleep 0.01; make all; done

.PHONY: reader
reader:
	echo "make reader"
	okular --geometry 1268x1099-0-34 $(PROJECT).pdf & echo $$! > okular.pid

.PHONY: editor
editor:
	echo "make editor"
	vim -S ~/.vim/vimrc $(PAPER)

.PHONY: tools
tools:
	echo "make tools"
	make reader
	make editor

=== minexpert/user-manual/CMakeLists.txt ===
message(STATUS "\nStarting configuring of the minexpert-user-manual material\n")

#############################################################
# There are warning issued during the compilation of almost
# any LaTeX source, but we want the compilation not to stop...
# Because the build process has -Werror set globally we want to
# disable it here specifically.
if(PEDANTIC)
	REMOVE_DEFINITIONS (-Werror)
endif(PEDANTIC)

if(UNIX AND NOT APPLE)

	set(CUR_DOC_DIR ${CMAKE_SOURCE_DIR}/minexpert/user-manual)
	set(CUR_DOC_BUILD_DIR ${CMAKE_CURRENT_BINARY_DIR}/build-user-manual)

	message(STATUS "Current doc directory: ${CUR_DOC_DIR}")
	message(STATUS "Current doc build directory: ${CUR_DOC_BUILD_DIR}")

	# Copy the directory to a build directory. This will also copy as "hard"
	# files, following the various symbolic links,  to other files in other places
	# in the source tree (preface.tex is an example, images/splashscreen.png or
	# images/addresses.png are two other examples; the files in
	# user-manual-common/figures that are linked in the local figures directory
	# also).
	execute_process(COMMAND cp -rpL ${CUR_DOC_DIR} ${CUR_DOC_BUILD_DIR}
		WORKING_DIRECTORY	${CMAKE_CURRENT_BINARY_DIR})

	# Make sure we use the Makefile that is located in the new directory, copy
	# of the original user-manual directory.
	add_custom_command(OUTPUT minexpert-doc.pdf
		COMMAND make -f ${CUR_DOC_BUILD_DIR}/Makefile usermanual
		WORKING_DIRECTORY ${CUR_DOC_BUILD_DIR}
		COMMENT "Build the mineXpert user manual")

	if(BUILD_USER_MANUALS)

		# Command:
		# make minexpert-user-manual
		add_custom_target(minexpert-user-manual ALL
			DEPENDS minexpert-doc.pdf
			COMMENT "Make minexpert-user-manual")

		# Command:
		# make copy-minexpert-doc.pdf
		add_custom_target(copy-minexpert-doc.pdf ALL
			COMMAND ${CMAKE_COMMAND} -E copy ${CUR_DOC_BUILD_DIR}/minexpert-doc.pdf
			${CMAKE_SOURCE_DIR}/minexpert/user-manual
			DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/minexpert-doc.pdf
			COMMENT "Copy the pdf file to the source doc dir.")

	endif()

endif()

if(PEDANTIC)
	ADD_DEFINITIONS (-Werror)
endif(PEDANTIC)

if(UNIX AND NOT APPLE)

	install(FILES ${CUR_DOC_BUILD_DIR}/minexpert-doc.pdf
		DESTINATION ${MINEXPERT_DOC_DIR})

elseif(APPLE)

	install(FILES ${CMAKE_SOURCE_DIR}/minexpert/user-manual/minexpert-doc.pdf
		DESTINATION ${MINEXPERT_DOC_DIR})

endif()

message(STATUS "\nFinished configuring of the minexpert-user-manual material.\n")

=== minexpert/user-manual/Makefile ===
PROJECT=minexpert-doc
okularPid=$(shell cat okular.pid)

PAPER=$(PROJECT).tex  # set the path to your TeX file here

SHELL=/bin/bash   # for the while loop below

noreader: 
	echo "make noreader"
	pdflatex --interaction nonstopmode -halt-on-error -file-line-error $(PAPER) && \
		pdflatex --interaction nonstopmode -halt-on-error -file-line-error $(PAPER)
	if [ -f $(PROJECT).idx ] ; \
		then \
		makeindex $(PROJECT).idx ; \
		fi
	pdflatex --interaction nonstopmode -halt-on-error -file-line-error $(PAPER) && \
		pdflatex --interaction nonstopmode -halt-on-error -file-line-error $(PAPER)
	touch noreader

.PHONY: usermanual
usermanual: noreader
# echo "make usermanual"

all:  ## Compile paper
	echo "make all"
	rubber --pdf $(PAPER); /usr/bin/test "$$?" -eq 0
	qdbus org.kde.okular-$(shell cat okular.pid) /okular reload

clean:  ## Clean output files
	echo "make clean"
	rm -f noreader
	rubber --clean $(PAPER)

watch:  ## Recompile on updates to the source file
	while [ 1 ]; do; inotifywait $(PAPER); sleep 0.01; make all; done

.PHONY: reader
reader:
	echo "make reader"
	okular --geometry 1268x1099-0-34 $(PROJECT).pdf & echo $$! > okular.pid

.PHONY: editor
editor:
	vim -S ~/.vim/vimrc $(PAPER)

.PHONY: tools
tools:
	echo "make tools"
	make reader
	make editor

=== debian/changelog ===
msxpertsuite (5.7.2-1) unstable; urgency=low

  * Bug fixes in upstream massXpert.

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 15 Jan 2019 22:05:46 +0100

msxpertsuite (5.7.1-1) unstable; urgency=low

  * Small fixes in upstream.

  * Ship the data and doc (all-architecture) material in dedicated packages.

 -- Filippo Rusconi <lopippo@debian.org>  Fri, 21 Dec 2018 17:07:40 +0100

msxpertsuite (5.7.0-2) UNRELEASED; urgency=low

  * Fix all -> any Arch silly error. Stupid.

 -- Filippo Rusconi <lopippo@debian.org>  Fri, 21 Dec 2018 16:16:12 +0100

msxpertsuite (5.7.0-1) unstable; urgency=low

  * New upstream release featuring the ability to shape a mass peak centroid
    into a Gaussian/Lorentzian configurable peak. Update the user manual to
    document that new feature.
 
  * Break msxpertsuite into two binary packages: msxpertsuite-massxpert and
    msxpertsuite-minexpert.

 -- Filippo Rusconi <lopippo@debian.org>  Fri, 21 Dec 2018 12:32:25 +0100

msxpertsuite (5.6.1-1) unstable; urgency=low

  * New upstream release to cope with the libpwiz API change in the
    BinaryDataEncoder class, with the creation of the new BinaryData class to
    handle what used to be std::vector<double>.

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 11 Dec 2018 17:42:41 +0100

msxpertsuite (5.6.0-1) unstable; urgency=low

  * New upstream version:
 
    - Improve the interpreation of script lines;
    - Start implementation of a JavaScript script file to calibrate the Synapt
      data.
    - Improve the mass data integration in script mode;
    - When creating mass spectrum from clipboard, automatically trigger the
      computation of the actual mass spectrum plot without requiring a TIC 
      to mass spectrum computation.
    - Provide Savitzky-Golay filtering to any trace in any plot widget with
      undo/redo feature.

 -- Filippo Rusconi <lopippo@debian.org>  Sat, 13 Oct 2018 11:59:05 +0200

msxpertsuite (5.5.3-3) unstable; urgency=low

  * Make sure we load the orig tar ball.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 04 Oct 2018 20:08:06 +0200

msxpertsuite (5.5.3-2) unstable; urgency=low

  * Abandon the developer documentation binary package that is too large.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 04 Oct 2018 17:30:09 +0200

msxpertsuite (5.5.3-1) unstable; urgency=low

  * mineXpert: Fix glitch with mouse drag in the axes that nonetheless
    triggers resolving power computation.

  * mineXpert: Make sure to test the ion mobility drift time as an xml string
    value and not as a double value. 

  * mineXpert: Make sure to craft an absolute path file name when exporting
    data in the SQLite3 db format.

  * massXpert: Fix how the user's polChemDefs directory and the polSeqs
    directory are searched for and detected.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 04 Oct 2018 13:18:19 +0200

msxpertsuite (5.5.2-1) UNRELEASED; urgency=low

  * Fix glitch due to calling the mouse press handler twice which triggered
    twice the computations elicited by the mouse press event.

 -- Filippo Rusconi <lopippo@debian.org>  Fri, 21 Sep 2018 13:24:34 +0200

msxpertsuite (5.5.1-1) UNRELEASED; urgency=low

  * Bug fix release to fix the bug that made the axes unclickable if the
    graphical items would be laid out in the "overlay" layer.

 -- Filippo Rusconi <lopippo@debian.org>  Fri, 21 Sep 2018 09:46:08 +0200

msxpertsuite (5.5.0-1) UNRELEASED; urgency=low

  * New upstream release;

  * mineXpert: Add new figures to the user manual and replace others. Update the user manual;
  
  * mineXpert: Provide a way for the user to configure the tolerance on the fractional part of the z value as is computed during deconvolution, document that new feature in the user manual;
  
  * mineXpert: Ensure that the selection line, start and end markers and texts overlaid on the colormap are white-colored so that they can be visible on the dark blue background;
  
  * mineXpert: Fix corner case crash when hitting Shift while right-button dragging in the colormap;
  
  * mineXpert: Improve GUI in the data slicer window;
  
  * mineXpert: When shift rescaling plots in multigraph plot widget, ensure the y axis full scale is determined on the basis of the greatest y value of all the graphs currently displayed in the view;
  
  * mineXpert: Allow changing the color of a TIC chrom plot right after data file loading (that is, even if it has no relations to other plots);
  
  * mineXpert: Replace ''TIC'' with ''XIC'' chromatogram text where needed;
  
  * mineXpert: Add computation of resolving power when mouse is moved over spectrum.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 20 Sep 2018 15:44:55 +0200

msxpertsuite (5.4.0-1) experimental; urgency=low

  * Port to the libqcustomplot 2.0.1 version. Mostly changes in the data
    format of the plot data in the QCustomPlot class.

  * Fix bug that made the program crash when converting data from mzML to
    SQLite3-based db format when Synapt ion mobility data contained NaN
    values.

  * Fix reporting in the console window of TIC intensity value calculations
    (no error on the result, only the reporting of that result).

  Bump-up standards version to 4.2.0, no changes required.

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 11 Sep 2018 19:31:02 +0200

=== debian/control ===
Source: msxpertsuite
Section: science
Priority: optional
Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
Uploaders: Filippo Rusconi <lopippo@debian.org>
Build-Depends: debhelper (>=9.20130630),
               dpkg-dev (>= 1.16.1~),
               graphicsmagick-imagemagick-compat,
               libgomp1,
               rubber (>= 1.4),
               qtbase5-dev (>= 5.7.0),
               libqt5svg5-dev (>= 5.7.0),
               qtscript5-dev (>= 5.7.0),
               cmake (>= 3.2.2-2),
               texlive-latex-recommended,
               biber,
               latex2html,
               texlive-fonts-recommended,
							 texlive-lang-french,
							 texlive-lang-cyrillic,
               libqcustomplot-dev(>= 2.0),
               libpwiz-dev(>=3.0.10827),
               libboost-dev (>= 1.56.0),
               docbook-to-man,
               libtclap-dev,
               gsfonts,
               doxygen,
               graphviz,
               qttools5-dev-tools,
               qtchooser
Standards-Version: 4.2.1
Homepage: https://www.msxpertsuite.org/
Vcs-Browser: https://salsa.debian.org/debichem-team/msxpertsuite.git
Vcs-Git: https://salsa.debian.org/debichem-team/msxpertsuite.git

Package: msxpertsuite
Architecture: any
Depends: ${misc:Depends},
         msxpertsuite-massxpert (>= ${source:Upstream-Version}),
         msxpertsuite-massxpert (<< ${source:Upstream-Version}A~),
         msxpertsuite-minexpert (>= ${source:Upstream-Version}),
         msxpertsuite-minexpert (<< ${source:Upstream-Version}A~)
Suggests: msxpertsuite-doc
Description: mass spectrometry software suite - metapackage
 msXpertSuite provides programs to model linear (bio-) polymer 
 chemistries, simulate mass spectral data, analyse and data-mine mass. 
 It is the successor of GNU polyXmass, first, and then of massXpert.
 .
 The massXpert and mineXpert programs allow the following:
 .
 massXpert:
  - making brand new polymer chemistry definitions;
  - using the definitions to perform easy calculations in a desktop
    calculator-like manner;
  - performing sophisticated polymer sequence editing and simulations;
  - perform m/z list comparisons;
 .
  Chemical simulations encompass cleavage (either chemical or
  enzymatic), gas-phase fragmentations, chemical modification of any
  monomer in the polymer sequence, cross-linking of monomers in the
  sequence, arbitrary mass searches, calculation of the isotopic
  pattern...
 .
 mineXpert:
  - Open mass spectrometry data files (mzML, mzXML, asc, xy, ...);
  - Calculate and display the TIC chromatogram;
  - For mobility data, calculate and display a mz=f(dt) color map;
  - Integrate the data from the TIC chromatogram or color map
    - to mass spectrum;
    - to drift spectrum;
    - back to TIC chromatogram (XIC chromatogram);
    - reverse operations;
    - to single TIC intensity value 
      (for mass spectral intensity comparisons);
  - Model centroids peaks into mass spectra using either the 
    Gaussian model or the Lorentzian model;
  - Export the data to text files;
  - Slice a big initial file into smaller chunks for easier mining;
  - Define how mining activity is recorded on disk for later use;
  - Convert mzML files into a private (albeit open) mass spectrometry
    format that allows better performance (based on SQLite3).
 .
 This package depends on both massXpert and mineXpert packages and thus will
 install both of them. To install only one of the packages, install the
 corresponding msxpertsuite-massxpert or msxpertsuite-minexpert package.


Package: msxpertsuite-massxpert
Architecture: any
Depends: ${shlibs:Depends},
				 ${misc:Depends},
         msxpertsuite-massxpert-data-doc (>= ${source:Upstream-Version}),
         msxpertsuite-massxpert-data-doc (<< ${source:Upstream-Version}A~)
Replaces: massxpert (<< 5.7.0), massxpert-doc (<< 5.7.0), msxpertsuite-data (<< 5.7.0), msxpertsuite-doc (<< 5.7.0), msxpertsuite(<< 5.7.0)
Breaks: massxpert (<< 5.7.0), massxpert-doc (<< 5.7.0), msxpertsuite-data (<< 5.7.0), msxpertsuite-doc (<< 5.7.0), msxpertsuite(<< 5.7.0)
Conflicts: massxpert-data (<< 5.7.0), massxpert (<< 5.7.0), msxpertsuite-data (<< 5.7.0), msxpertsuite-doc (<< 5.7.0), msxpertsuite(<< 5.7.0)
Description: mass spectrometry software suite - massXpert
 msXpertSuite provides programs to model linear (bio-) polymer 
 chemistries, simulate mass spectral data, analyse and data-mine mass. 
 It is the successor of GNU polyXmass, first, and then of massXpert.
 .
 This package ships the massXpert program.


Package: msxpertsuite-massxpert-data-doc
Architecture: all
Depends: ${misc:Depends}
Replaces: massxpert-data (<< 5.7.0), massxpert-doc (<< 5.7.0), msxpertsuite-data (<< 5.7.0), msxpertsuite-doc (<< 5.7.0), msxpertsuite(<< 5.7.0)
Breaks: massxpert-data (<< 5.7.0), massxpert-doc (<< 5.7.0), msxpertsuite-data (<< 5.7.0), msxpertsuite-doc (<< 5.7.0), msxpertsuite(<< 5.7.0)
Conflicts: massxpert-data (<< 5.7.0), massxpert-doc (<< 5.7.0), msxpertsuite-data (<< 5.7.0), msxpertsuite-doc (<< 5.7.0), msxpertsuite(<< 5.7.0)
Description: mass spectrometry software suite - massXpert - data and doc
 msXpertSuite provides programs to model linear (bio-) polymer 
 chemistries, simulate mass spectral data, analyse and data-mine mass. 
 It is the successor of GNU polyXmass, first, and then of massXpert.
 .
 This package ships the data used by massXpert and its documentation.


Package: msxpertsuite-minexpert
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         msxpertsuite-minexpert-data-doc (>= ${source:Upstream-Version}),
         msxpertsuite-minexpert-data-doc (<< ${source:Upstream-Version}A~)
Replaces: msxpertsuite-doc (<< 5.7.0), msxpertsuite (<< 5.7.0)
Breaks: msxpertsuite-doc (<< 5.7.0), msxpertsuite (<< 5.7.0)
Conflicts: msxpertsuite-doc (<< 5.7.0), msxpertsuite (<< 5.7.0)
Description: mass spectrometry software suite - mineXpert
 msXpertSuite provides programs to model linear (bio-) polymer 
 chemistries, simulate mass spectral data, analyse and data-mine mass. 
 It is the successor of GNU polyXmass, first, and then of massXpert.
 .
 This package ships the mineXpert program.


Package: msxpertsuite-minexpert-data-doc
Architecture: all
Depends: ${misc:Depends}
Replaces: msxpertsuite-doc (<< 5.7.0), msxpertsuite (<< 5.7.0)
Breaks: msxpertsuite-doc (<< 5.7.0), msxpertsuite (<< 5.7.0)
Conflicts: msxpertsuite-doc (<< 5.7.0), msxpertsuite (<< 5.7.0)
Description: mass spectrometry software suite - mineXpert - data and doc
 msXpertSuite provides programs to model linear (bio-) polymer 
 chemistries, simulate mass spectral data, analyse and data-mine mass. 
 It is the successor of GNU polyXmass, first, and then of massXpert.
 .
 This package ships the data used by mineXpert and its documentation.

=== debian/rules ===
#!/usr/bin/make -f
# Based on the initial work of Joey Hess and Craig Small.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

CMAKE=/usr/bin/cmake

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

BUILD_DIR = $(CURDIR)/debian/build

INSTALL_INDEP_DIR = $(CURDIR)/debian/tmp-indep
INSTALL_ARCH_DIR = $(CURDIR)/debian/tmp-arch

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CXXFLAGS += -O0
else
	CXXFLAGS += -O2
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
         NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
         MAKEFLAGS += -j$(NUMJOBS)
endif

$(info "---------------------------------------")
$(info NUMJOBS: $(NUMJOBS))
$(info MAKEFLAGS: $(MAKEFLAGS))
$(info DEB_BUILD_OPTIONS: $(DEB_BUILD_OPTIONS))
$(info "---------------------------------------")

# Hardening stuff for debhelper compat level 9, see
# http://wiki.debian.org/Hardening

# To enable all, uncomment following line
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

.NOTPARALLEL:

.PHONY: clean
clean:
	dh_testdir
	dh_testroot

# The following is for the binary software
	rm -rf $(BUILD_DIR)
	rm -rf $(INSTALL_INDEP_DIR) $(INSTALL_ARCH_DIR)

# Remove the generated files (even if by CMake).
	rm -f msxpertsuite-doc.7 \
	 massxpert/data/msxpertsuite-data.7 \
	 massxpert/massxpert.1 \
	 minexpert/minexpert.1

# The user manuals, after creation in the build tree are exported to the source
# tree. Remove them.
	rm -f massxpert/user-manual/massxpert-doc.pdf \
		minexpert/user-manual/minexpert-doc.pdf

	dh_clean


build-indep-stamp:
	dh_testdir -i
	dh_prep -i

	rm -rf $(INSTALL_INDEP_DIR)
	mkdir -p $(BUILD_DIR)

# The following is for building of the user manual
	cd $(BUILD_DIR) && \
	$(CMAKE) \
	-DOPENMP=1 \
	-DDEBUG=1 \
	-DBUILD_USER_MANUALS=1 \
	-DCMAKE_INSTALL_PREFIX=/usr ../..

	cd $(BUILD_DIR) && $(MAKE) -j1 massxpert-user-manual

	cd $(BUILD_DIR) && $(MAKE) -j1 minexpert-user-manual

	touch build-indep-stamp


build-arch-stamp:
	dh_testdir -a
	dh_prep -a
	dh_installdirs -i

	rm -rf $(INSTALL_ARCH_DIR)
	mkdir -p $(BUILD_DIR)

# The following is for building of the binary msxpertsuite software
	cd $(BUILD_DIR) && \
	$(CMAKE) \
	-DOPENMP=1 \
	-DDEBUG=1 \
	-DBUILD_USER_MANUALS=0 \
	-DCMAKE_INSTALL_PREFIX=/usr ../..

	cd $(BUILD_DIR) && $(MAKE) -j1 massxpert
	cd $(BUILD_DIR) && $(MAKE) -j1 minexpert

	touch build-arch-stamp


.PHONY: build
build: build-indep-stamp build-arch-stamp

.PHONY: build-indep
build-indep: build-indep-stamp

.PHONY: build-arch
build-arch: build-arch-stamp


install-indep-stamp: build-indep-stamp
	dh_testdir -i
	dh_testroot -i
	dh_installdirs -i

	mkdir -p $(INSTALL_INDEP_DIR)

# The general doc stuff
	$(MAKE) -C $(BUILD_DIR)/doc install DESTDIR=$(INSTALL_INDEP_DIR)

# But, now remove the license file
	rm $(INSTALL_INDEP_DIR)/usr/share/doc/msxpertsuite-massxpert/doc/COPYING
	rm $(INSTALL_INDEP_DIR)/usr/share/doc/msxpertsuite-minexpert/doc/COPYING

# Finally the indep data
	$(MAKE) -C $(BUILD_DIR)/massxpert/data install DESTDIR=$(INSTALL_INDEP_DIR)

# The user manuals

	$(MAKE) -C $(BUILD_DIR)/massxpert/user-manual install DESTDIR=$(INSTALL_INDEP_DIR)
#	DESTDIR=$(INSTALL_INDEP_DIR) $(CMAKE) -DCOMPONENT=usermanual -P $(BUILD_DIR)/massxpert/cmake_install.cmake

	$(MAKE) -C $(BUILD_DIR)/minexpert/user-manual install DESTDIR=$(INSTALL_INDEP_DIR)
#	DESTDIR=$(INSTALL_INDEP_DIR) $(CMAKE) -DCOMPONENT=usermanual -P $(BUILD_DIR)/minexpert/cmake_install.cmake

	touch install-indep-stamp


install-arch-stamp: build-arch-stamp
	dh_testdir
	dh_testroot
	dh_installdirs -a

	mkdir -p $(INSTALL_ARCH_DIR)

	# Install menu pixmap
	install -o root -g root -d $(INSTALL_ARCH_DIR)/usr/share/pixmaps
	install -o root -g root -m 644 \
		$(CURDIR)/images/msxpertsuite-icon-32.xpm \
		$(INSTALL_ARCH_DIR)/usr/share/pixmaps/msxpertsuite-icon-32.xpm

	touch install-arch-stamp


# Build architecture-independent files here.
.PHONY: binary-indep
binary-indep: install-indep-stamp
	dh_prep -i
	dh_testdir -i
	dh_testroot -i
	dh_installchangelogs -i

# symlink the jquery.js file
	dh_link -i
	dh_installdocs -i
	dh_install -i
	dh_installman -i
	dh_compress -Xmassxpert-doc.pdf -Xminexpert-doc.pdf -i
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i


# Build architecture-dependent files here.
.PHONY: binary-arch
binary-arch: install-arch-stamp
	dh_prep -a
	dh_testdir -a
	dh_testroot -a
	dh_installchangelogs  -a
	dh_installdocs -a
	dh_install -a
	dh_installman -a
	dh_strip -a
	dh_compress -a
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a


.PHONY: binary
binary: binary-indep binary-arch
